#include <SPI.h>

const int slaveSelectPin = 10;

void print_binary(int number, byte Length){
  static int Bits;
  if (number) { //The remaining bits have a value greater than zero continue
    Bits++; // Count the number of bits so we know how many leading zeros to print first
    print_binary(number >> 1, Length); // Remove a bit and do a recursive call this function.
    if (Bits) for (byte x = (Length - Bits); x; x--)Serial.write('0'); // Add the leading zeros
    Bits = 0; // clear no need for this any more
    Serial.write((number & 1) ? '1' : '0'); // print the bits in reverse order as we depart the recursive function
  }
}

void setup() {
  // set the slaveSelectPin as an output:
  pinMode(slaveSelectPin, OUTPUT);
  // initialize SPI:
  //SPI.beginTransaction(SPISettings(125000, MSBFIRST, SPI_MODE0));
  digitalWrite(slaveSelectPin,HIGH);

  Serial.begin(115200);

  SPI.beginTransaction(SPISettings(1000000, MSBFIRST, SPI_MODE0));

  SPI.begin();
}

void loop() {
  int val;
  int val2;
  int val3;
  int val4;
  digitalWrite(slaveSelectPin,LOW);
  val = SPI.transfer(0x00);
  val2 = SPI.transfer(0x00);
  val3 = SPI.transfer(0xAA);
  val4 = SPI.transfer(0x00);
  digitalWrite(slaveSelectPin,HIGH);
  /*for (int i = 0; i < 8; i++)
  {
    Serial.print(val & (1<<i));
    Serial.print(" ");
  }


 
  for (int i = 0; i < 8; i++)
  {
    Serial.print(val2 & (1<<i));
    Serial.print(" ");
  }*/

  print_binary(val, 8);
  //Serial.print(val, BIN);
  Serial.print(" ");
  print_binary(val2, 8);
  //Serial.print(val2, BIN);
  Serial.print(" ");
  print_binary(val3, 8);
  //Serial.print(val3, BIN);
  Serial.print(" ");
  print_binary(val4, 8);
  //Serial.print(val4, BIN);
  Serial.print(" ");

  Serial.println();

  delay(100);

}

void loopOutput() {
  int val;
  //SPI.transfer(0b010000000010000000010000);
  digitalWrite(slaveSelectPin,LOW);
  val = SPI.transfer(0b1);
  Serial.print(val);
  val = SPI.transfer(0b10);
  Serial.print(val);
  val = SPI.transfer(0b100);
  Serial.println(val);

  digitalWrite(slaveSelectPin,HIGH);

  delay(500);
  digitalWrite(slaveSelectPin,LOW);
  val = SPI.transfer(0xFF);
  Serial.print(val);

  val = SPI.transfer(0xFF);
  Serial.print(val);

  val = SPI.transfer(0xFF);
  Serial.println(val);

  digitalWrite(slaveSelectPin,HIGH);
  delay(500);

}
